' This class is "generated" and will be overwritten.
' Your customizations should be made in ShowPersonalIdTableRecord.vb

Imports System.Data.SqlTypes
Imports BaseClasses
Imports BaseClasses.Data
Imports BaseClasses.Data.SqlProvider

Namespace Persons.Business

''' <summary>
''' The generated superclass for the <see cref="ShowPersonalIdTableRecord"></see> class.
''' </summary>
''' <remarks>
''' This class is not intended to be instantiated directly.  To obtain an instance of this class, 
''' use the methods of the <see cref="ShowPersonalIdTableQuery"></see> class.
''' </remarks>
''' <seealso cref="ShowPersonalIdTableQuery"></seealso>
''' <seealso cref="ShowPersonalIdTableRecord"></seealso>

<Serializable()> Public Class BaseShowPersonalIdTableRecord
	Inherits VirtualRecord

	Public Shared Shadows ReadOnly TableUtils As ShowPersonalIdTableQuery = ShowPersonalIdTableQuery.Instance

	Protected Sub New()
		MyBase.New(TableUtils)
		Me.LoadInnerRecords()
	End Sub

	Public Sub New(ByVal record As VirtualRecord)
		MyBase.New(record, TableUtils)
		Me.LoadInnerRecords()
	End Sub
	
		'Evaluates Initialize when->Inserting record formulas specified at the data access layer
    Public Overridable Sub ShowPersonalIdTableRecord_InsertingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.InsertingRecord
        'Apply Initialize->Inserting record formula only if validation is successful.
        	        Dim ShowPersonalIdTableRec As ShowPersonalIdTableRecord = CType(sender,ShowPersonalIdTableRecord)
        Validate_Inserting()
        If Not ShowPersonalIdTableRec Is Nothing AndAlso Not ShowPersonalIdTableRec.IsReadOnly Then
                End If
    End Sub

	'Evaluates Initialize when->Updating record formulas specified at the data access layer
    Public Overridable Sub ShowPersonalIdTableRecord_UpdatingRecord(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.UpdatingRecord
        'Apply Initialize->Updating record formula only if validation is successful.
        	        Dim ShowPersonalIdTableRec As ShowPersonalIdTableRecord = CType(sender,ShowPersonalIdTableRecord)
        Validate_Updating()
        If Not ShowPersonalIdTableRec Is Nothing AndAlso Not ShowPersonalIdTableRec.IsReadOnly Then
                End If
    End Sub
    
    'Evaluates Initialize when->Reading record formulas specified at the data access layer
    Public Overridable Sub ShowPersonalIdTableRecord_ReadRecord(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.ReadRecord
        'Apply Initialize->Reading record formula only if validation is successful.
        	        Dim ShowPersonalIdTableRec As ShowPersonalIdTableRecord = CType(sender,ShowPersonalIdTableRecord)
        If Not ShowPersonalIdTableRec Is Nothing AndAlso Not ShowPersonalIdTableRec.IsReadOnly Then
                End If
    End Sub
    
   'Evaluates Validate when->Inserting formulas specified at the data access layer
   Public Overridable Sub Validate_Inserting ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
	
	'Evaluates Validate when->Updating formulas specified at the data access layer
   Public Overridable Sub Validate_Updating ()
		Dim fullValidationMessage As String = ""
		Dim validationMessage As String = ""

		dim formula as String = ""


		If validationMessage <> "" AndAlso validationMessage.ToLower() <> "true" Then
			fullValidationMessage &= validationMessage & vbCrLf
		End If

		If fullValidationMessage <> "" Then
			Throw New Exception(fullValidationMessage)
		End If 
	End Sub
 
	Public Overridable Function EvaluateFormula(ByVal formula As String, Optional ByVal dataSourceForEvaluate As BaseClasses.Data.BaseRecord = Nothing, Optional ByVal format As String = Nothing) As String

		Dim e As Data.BaseFormulaEvaluator = New Data.BaseFormulaEvaluator()

            ' All variables referred to in the formula are expected to be
            ' properties of the DataSource.  For example, referring to
            ' UnitPrice as a variable will refer to DataSource.UnitPrice
            e.DataSource = dataSourceForEvaluate

            Dim resultObj As Object = e.Evaluate(formula)
            If resultObj Is Nothing Then
                Return ""
            End If
        	Return resultObj.ToString()
	End Function

#Region "Convenience method implementations for columns"

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.Addr field.
	''' </summary>
	Public Function GetAddr_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.Addr_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.Addr field.
	''' </summary>
	Public Function GetAddr_PersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.Addr_PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.Addr field.
	''' </summary>
	Public Sub SetAddr_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Addr_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.Addr field.
	''' </summary>
	Public Sub SetAddr_PersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Addr_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.Amphur field.
	''' </summary>
	Public Function GetAmphur_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.Amphur_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.Amphur field.
	''' </summary>
	Public Function GetAmphur_PersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.Amphur_PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.Amphur field.
	''' </summary>
	Public Sub SetAmphur_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Amphur_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.Amphur field.
	''' </summary>
	Public Sub SetAmphur_PersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Amphur_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.BirthDate field.
	''' </summary>
	Public Function GetBirthDate_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.BirthDate_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.BirthDate field.
	''' </summary>
	Public Function GetBirthDate_PersonalIdFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.BirthDate_PersonalIdColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.BirthDate field.
	''' </summary>
	Public Sub SetBirthDate_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.BirthDate_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.BirthDate field.
	''' </summary>
	Public Sub SetBirthDate_PersonalIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.BirthDate_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.BirthDate field.
	''' </summary>
	Public Sub SetBirthDate_PersonalIdFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.BirthDate_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.Born field.
	''' </summary>
	Public Function GetBorn_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.Born_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.Born field.
	''' </summary>
	Public Function GetBorn_PersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.Born_PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.Born field.
	''' </summary>
	Public Sub SetBorn_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Born_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.Born field.
	''' </summary>
	Public Sub SetBorn_PersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Born_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.DeptId field.
	''' </summary>
	Public Function GetDeptId_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.DeptId_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.DeptId field.
	''' </summary>
	Public Function GetDeptId_PersonalIdFieldValue() As Int16
		Return CType(Me.GetValue(TableUtils.DeptId_PersonalIdColumn).ToInt16(), Int16)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.DeptId field.
	''' </summary>
	Public Sub SetDeptId_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.DeptId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.DeptId field.
	''' </summary>
	Public Sub SetDeptId_PersonalIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.DeptId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.DeptId field.
	''' </summary>
	Public Sub SetDeptId_PersonalIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.DeptId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.DeptId field.
	''' </summary>
	Public Sub SetDeptId_PersonalIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.DeptId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.DeptId field.
	''' </summary>
	Public Sub SetDeptId_PersonalIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.DeptId_PersonalIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.MobilePhone field.
	''' </summary>
	Public Function GetMobilePhone_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.MobilePhone_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.MobilePhone field.
	''' </summary>
	Public Function GetMobilePhone_PersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.MobilePhone_PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.MobilePhone field.
	''' </summary>
	Public Sub SetMobilePhone_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.MobilePhone_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.MobilePhone field.
	''' </summary>
	Public Sub SetMobilePhone_PersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.MobilePhone_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.OfficerDate field.
	''' </summary>
	Public Function GetOfficerDate_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.OfficerDate_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.OfficerDate field.
	''' </summary>
	Public Function GetOfficerDate_PersonalIdFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.OfficerDate_PersonalIdColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.OfficerDate field.
	''' </summary>
	Public Sub SetOfficerDate_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.OfficerDate_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.OfficerDate field.
	''' </summary>
	Public Sub SetOfficerDate_PersonalIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.OfficerDate_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.OfficerDate field.
	''' </summary>
	Public Sub SetOfficerDate_PersonalIdFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.OfficerDate_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.PersonalName field.
	''' </summary>
	Public Function GetPersonalName_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.PersonalName_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.PersonalName field.
	''' </summary>
	Public Function GetPersonalName_PersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PersonalName_PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.PersonalName field.
	''' </summary>
	Public Sub SetPersonalName_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PersonalName_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.PersonalName field.
	''' </summary>
	Public Sub SetPersonalName_PersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PersonalName_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.picture field.
	''' </summary>
	Public Function Getpicture_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.picture_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.picture field.
	''' </summary>
	Public Function Getpicture_PersonalIdFieldValue() As Byte()
		Return CType(Me.GetValue(TableUtils.picture_PersonalIdColumn).ToBinary(), Byte())
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.picture field.
	''' </summary>
	Public Sub Setpicture_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.picture_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.picture field.
	''' </summary>
	Public Sub Setpicture_PersonalIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.picture_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.picture field.
	''' </summary>
	Public Sub Setpicture_PersonalIdFieldValue(ByVal val As Byte ())
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.picture_PersonalIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.Province field.
	''' </summary>
	Public Function GetProvince_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.Province_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.Province field.
	''' </summary>
	Public Function GetProvince_PersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.Province_PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.Province field.
	''' </summary>
	Public Sub SetProvince_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.Province_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.Province field.
	''' </summary>
	Public Sub SetProvince_PersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.Province_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.PersonalId field.
	''' </summary>
	Public Function GetPersonalId_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.PersonalId_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.PersonalId field.
	''' </summary>
	Public Function GetPersonalId_PersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PersonalId_PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.PersonalId field.
	''' </summary>
	Public Sub SetPersonalId_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PersonalId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.PersonalId field.
	''' </summary>
	Public Sub SetPersonalId_PersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PersonalId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.RankId field.
	''' </summary>
	Public Function GetRankId_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.RankId_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.RankId field.
	''' </summary>
	Public Function GetRankId_PersonalIdFieldValue() As Int32
		Return CType(Me.GetValue(TableUtils.RankId_PersonalIdColumn).ToInt32(), Int32)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.RankId field.
	''' </summary>
	Public Sub SetRankId_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.RankId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.RankId field.
	''' </summary>
	Public Sub SetRankId_PersonalIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.RankId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.RankId field.
	''' </summary>
	Public Sub SetRankId_PersonalIdFieldValue(ByVal val As Double)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.RankId field.
	''' </summary>
	Public Sub SetRankId_PersonalIdFieldValue(ByVal val As Decimal)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankId_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.RankId field.
	''' </summary>
	Public Sub SetRankId_PersonalIdFieldValue(ByVal val As Int64)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.RankId_PersonalIdColumn)
	End Sub
	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.DateRank field.
	''' </summary>
	Public Function GetDateRank_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.DateRank_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.DateRank field.
	''' </summary>
	Public Function GetDateRank_PersonalIdFieldValue() As DateTime
		Return CType(Me.GetValue(TableUtils.DateRank_PersonalIdColumn).ToDateTime(), DateTime)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.DateRank field.
	''' </summary>
	Public Sub SetDateRank_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.DateRank_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.DateRank field.
	''' </summary>
	Public Sub SetDateRank_PersonalIdFieldValue(ByVal val As String)
		Me.SetString(val, TableUtils.DateRank_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.DateRank field.
	''' </summary>
	Public Sub SetDateRank_PersonalIdFieldValue(ByVal val As DateTime)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.DateRank_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.PersonalLastName field.
	''' </summary>
	Public Function GetPersonalLastName_PersonalIdValue() As ColumnValue
		Return Me.GetValue(TableUtils.PersonalLastName_PersonalIdColumn)
	End Function

	''' <summary>
	''' This is a convenience method that provides direct access to the value of the record's PersonalId.PersonalLastName field.
	''' </summary>
	Public Function GetPersonalLastName_PersonalIdFieldValue() As String
		Return CType(Me.GetValue(TableUtils.PersonalLastName_PersonalIdColumn).ToString(), String)
	End Function

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.PersonalLastName field.
	''' </summary>
	Public Sub SetPersonalLastName_PersonalIdFieldValue(ByVal val As ColumnValue)
		Me.SetValue(val, TableUtils.PersonalLastName_PersonalIdColumn)
	End Sub

	''' <summary>
	''' This is a convenience method that allows direct modification of the value of the record's PersonalId.PersonalLastName field.
	''' </summary>
	Public Sub SetPersonalLastName_PersonalIdFieldValue(ByVal val As String)
		Dim colValue As ColumnValue = New ColumnValue(val)
		Me.SetValue(colValue, TableUtils.PersonalLastName_PersonalIdColumn)
	End Sub



#End Region

#Region "Convenience method implementations for column names"

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.Addr field.
	''' </summary>
	Public Property Addr_PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.Addr_PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.Addr_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Addr_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Addr_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Addr_PersonalIdDefault() As String
        Get
            Return TableUtils.Addr_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.Amphur field.
	''' </summary>
	Public Property Amphur_PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.Amphur_PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.Amphur_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Amphur_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Amphur_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Amphur_PersonalIdDefault() As String
        Get
            Return TableUtils.Amphur_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.BirthDate field.
	''' </summary>
	Public Property BirthDate_PersonalId() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.BirthDate_PersonalIdColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.BirthDate_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property BirthDate_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.BirthDate_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property BirthDate_PersonalIdDefault() As String
        Get
            Return TableUtils.BirthDate_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.Born field.
	''' </summary>
	Public Property Born_PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.Born_PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.Born_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Born_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Born_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Born_PersonalIdDefault() As String
        Get
            Return TableUtils.Born_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.DeptId field.
	''' </summary>
	Public Property DeptId_PersonalId() As Int16
		Get 
			Return CType(Me.GetValue(TableUtils.DeptId_PersonalIdColumn).ToInt16(), Int16)
		End Get
		Set (ByVal val As Int16) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.DeptId_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property DeptId_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.DeptId_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property DeptId_PersonalIdDefault() As String
        Get
            Return TableUtils.DeptId_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.MobilePhone field.
	''' </summary>
	Public Property MobilePhone_PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.MobilePhone_PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.MobilePhone_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property MobilePhone_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.MobilePhone_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property MobilePhone_PersonalIdDefault() As String
        Get
            Return TableUtils.MobilePhone_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.OfficerDate field.
	''' </summary>
	Public Property OfficerDate_PersonalId() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.OfficerDate_PersonalIdColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.OfficerDate_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property OfficerDate_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.OfficerDate_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property OfficerDate_PersonalIdDefault() As String
        Get
            Return TableUtils.OfficerDate_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.PersonalName field.
	''' </summary>
	Public Property PersonalName_PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PersonalName_PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PersonalName_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PersonalName_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PersonalName_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PersonalName_PersonalIdDefault() As String
        Get
            Return TableUtils.PersonalName_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.picture field.
	''' </summary>
	Public Property picture_PersonalId() As Byte()
		Get 
			Return CType(Me.GetValue(TableUtils.picture_PersonalIdColumn).ToBinary(), Byte())
		End Get
		Set (ByVal val As Byte ()) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.picture_PersonalIdColumn)
		End Set
	End Property



	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property picture_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.picture_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property picture_PersonalIdDefault() As String
        Get
            Return TableUtils.picture_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.Province field.
	''' </summary>
	Public Property Province_PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.Province_PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.Province_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property Province_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.Province_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property Province_PersonalIdDefault() As String
        Get
            Return TableUtils.Province_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.PersonalId field.
	''' </summary>
	Public Property PersonalId_PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PersonalId_PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PersonalId_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PersonalId_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PersonalId_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PersonalId_PersonalIdDefault() As String
        Get
            Return TableUtils.PersonalId_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.RankId field.
	''' </summary>
	Public Property RankId_PersonalId() As Int32
		Get 
			Return CType(Me.GetValue(TableUtils.RankId_PersonalIdColumn).ToInt32(), Int32)
		End Get
		Set (ByVal val As Int32) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.RankId_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property RankId_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.RankId_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property RankId_PersonalIdDefault() As String
        Get
            Return TableUtils.RankId_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.DateRank field.
	''' </summary>
	Public Property DateRank_PersonalId() As DateTime
		Get 
			Return CType(Me.GetValue(TableUtils.DateRank_PersonalIdColumn).ToDateTime(), DateTime)
		End Get
		Set (ByVal val As DateTime) 
			Dim colValue As ColumnValue = New ColumnValue(val)
			Me.SetValue(colValue, TableUtils.DateRank_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property DateRank_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.DateRank_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property DateRank_PersonalIdDefault() As String
        Get
            Return TableUtils.DateRank_PersonalIdColumn.DefaultValue
        End Get
    End Property

	''' <summary>
	''' This is a convenience property that provides direct access to the value of the record's PersonalId.PersonalLastName field.
	''' </summary>
	Public Property PersonalLastName_PersonalId() As String
		Get 
			Return CType(Me.GetValue(TableUtils.PersonalLastName_PersonalIdColumn).ToString(), String)
		End Get
		Set (ByVal Value As String) 
			Me.SetString(value, TableUtils.PersonalLastName_PersonalIdColumn)
		End Set
	End Property


	''' <summary>
	''' This is a convenience method that can be used to determine that the column is set.
	''' </summary>
	Public ReadOnly Property PersonalLastName_PersonalIdSpecified() As Boolean
        Get
            Dim val As ColumnValue = Me.GetValue(TableUtils.PersonalLastName_PersonalIdColumn)
            If val Is Nothing OrElse val.IsNull Then
                Return False
            End If
            Return True
        End Get
    End Property

	''' <summary>
	''' This is a convenience method that can be used to get the default value of a column.
	''' </summary>
    Public ReadOnly Property PersonalLastName_PersonalIdDefault() As String
        Get
            Return TableUtils.PersonalLastName_PersonalIdColumn.DefaultValue
        End Get
    End Property



#End Region

End Class
End Namespace
